/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2009 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/
#include <stdio.h>
#include "NUC1xx.h"
#include "Driver\DrvGPIO.h"
#include "Driver\DrvUART.h"
#include "Driver\DrvSYS.h"


// GPIOE.0 -> LCD RS
// GPIOE.1 -> LCD R/W
// GPIOE.2 -> LCD E
// GPIOA.0 -> LCD DB0
// GPIOA.1 -> LCD DB1
// GPIOA.2 -> LCD DB2
// GPIOA.3 -> LCD DB3
// GPIOA.4 -> LCD DB4
// GPIOA.5 -> LCD DB5
// GPIOA.6 -> LCD DB6
// GPIOA.7 -> LCD DB7

#define LCD_DATA    GPIOA->DOUT
#define LCD_RS_SET  DrvGPIO_SetBit(E_GPE,0) // RSźΪ
#define LCD_RS_CLR  DrvGPIO_ClrBit(E_GPE,0) // RSźΪ
#define LCD_RW_SET  DrvGPIO_SetBit(E_GPE,1) // R/WźΪ
#define LCD_RW_CLR  DrvGPIO_ClrBit(E_GPE,1) // R/WźΪ
#define LCD_E_SET   DrvGPIO_SetBit(E_GPE,2) // EźΪ
#define LCD_E_CLR   DrvGPIO_ClrBit(E_GPE,2) // EźΪ


void WriteDataLcd(unsigned char wdata)
{
    LCD_DATA=wdata;
    LCD_RS_SET;
    LCD_RW_CLR;
    LCD_E_CLR;
    DrvSYS_Delay(1000);

    LCD_E_SET;
}

void WriteCommandLcd(unsigned char wdata)
{
    LCD_DATA=wdata;
    LCD_RS_CLR;
    LCD_RW_CLR;
    LCD_E_CLR;   
    DrvSYS_Delay(1000);
    LCD_E_SET;
}

//LCDʼ
void lcd_init(void)
{
    LCD_DATA=0;
    WriteCommandLcd(0x38);  // LCD趨: DL=8-bit, N=2-line, F=5x8 dots
    DrvSYS_Delay(10000);
    WriteCommandLcd(0x38);
    WriteCommandLcd(0x08);  // ʾ: D=0 Display Off, C=0 Cursor Off, B=0 Blinks Off.
    WriteCommandLcd(0x01);  // ʾ
    WriteCommandLcd(0x06);  // ģʽ趨: I/D=1 Increment, S=0 Display does not shift.
    WriteCommandLcd(0x0C);  // ʾ: D=0 Display On, C=0 Cursor Off, B=0 Blinks Off.
}

void display_xy(unsigned char x,unsigned char y)
{
    if(y==1)
        x+=0x40;            // For 2nd line
    x+=0x80;
    WriteCommandLcd(x);
}

void display_char(unsigned char x,unsigned char y,unsigned char dat)
{
    display_xy(x,y);
    WriteDataLcd(dat);
}

void  display_string(unsigned  char x,unsigned  char y,unsigned  char *s)
{
    display_xy(x,y);
    while(*s)
    {
        WriteDataLcd(*s);
        s++;
    }
}

unsigned char  LcdBuf1[]= {"Welcome!"};
unsigned char  LcdBuf2[]= {"NuMicro M0"};

int main (void)
{
    lcd_init();
    display_string(2,0,LcdBuf1);    // LcdBuf1ϢLCDĵһеַʼʾ
    display_string(0,1,LcdBuf2);    // LcdBuf2ϢLCDĵڶеһַʼʾ
    while(1);
}


